//+----------------------------------------------------------------+
//| TestEA                                                         |
//| IntraDay Scalping                                                   |
//       http://www.forex-tsd.com/ideas-suggestions/16059-scalp-freedom-10-20-pips-trade-guaranteed.html
//+----------------------------------------------------------------+ 
// Input Variables 
 extern string EAVariables="";
 extern string CurSymbol = "EURUSD"; 
 extern int    MaxSpread = 50;    // Max spread in points
 extern int    Slippage  =  5;    // Max slippage in points
 extern int    MaxOrders =  1;    // Max orders open
 extern int    StartTime = 00;    // Start time hours
 extern int    EndTime=    24;   // End time hours
 extern double MultiLotSize = 0.01;  // Multiplie Lot Size

// Remaining parameters
 int Ticket,Total;
 double Lot,ClosingTime, Spread;
 bool FirstTime=true;
 
//+----------------------------------------------------------------+
//| Int init function                                              |
//+----------------------------------------------------------------+ 
int init()
  {
  return(0);
  }

  
//+----------------------------------------------------------------+
//| Start function                                                 |
//+----------------------------------------------------------------+  
int start()
  {  
  double UP1=iCustom(CurSymbol,0,"Freedom",1,0); //1UP
  double DN1=iCustom(CurSymbol,0,"Freedom",0,0); //1DN
  double UP2=iCustom(CurSymbol,0,"Freedom",3,0); //2UP
  double DN2=iCustom(CurSymbol,0,"Freedom",2,0); //2DN
  double UP3=iCustom(CurSymbol,0,"Freedom",5,0); //3UP
  double DN3=iCustom(CurSymbol,0,"Freedom",4,0); //3DN
  double UP4=iCustom(CurSymbol,0,"Freedom",7,0); //4UP
  double DN4=iCustom(CurSymbol,0,"Freedom",6,0); //4DN
              
// Is it a time in which the market tends to have a lot volalitily?  
   bool TradingTime=false;
   if(Hour()>= (StartTime)  && Hour() <EndTime)
      TradingTime=true;
                       
 if (OrdersTotal()==0 && TradingTime || FirstTime)  
   {
    FirstTime=false;      
// Open Long Position 
    if(SpreadFinder() < MaxSpread )
      {
       if(!AccountFreeMarginCheck(Symbol(),OP_SELL,LotSize())<=0)
         { 
          if(UP1==1 && UP2==1 && UP3==1)// && CCI1O>0.00 && CCI2O>0.00 && CCI3O>0.00 )
            {      
             OpenLong(LotSize());
             return(0); 
            }
         }
      }      
// Open Short Position
     if(SpreadFinder() < MaxSpread)
       {
        if(!AccountFreeMarginCheck(Symbol(),OP_SELL,LotSize())<=0)
          {
           if(DN1==1 && DN2==1 && DN3==1)  
             {            
              OpenShort(LotSize());
              return(0);
             }  
          }
      }                 
// End OrdersTotal==0 Function         
    } 
      
// Control Open positions
   if(OrdersTotal()==1 && Seconds()==00)
   {
    OrderSelect(0, SELECT_BY_POS);
    if(OrderType()==OP_BUY)
        { 
// Take Profit   
         if(DN1==1 || DN2==1 || DN3==1)
            {        
            OrderClose(Ticket,LotSize(),Bid,Slippage,Red);
            return(0);                      
            }
        }

    if(OrderType()==OP_SELL)
        {
// Take Profit   
         if(UP1==1 || UP2==1 || UP3==1)
            {      
            OrderClose(Ticket,LotSize(),Ask,Slippage,Green);      
            return(0);                      
            }

        }
// End Orderstotal==1 Function           
    }
   
  return(0);   
 }


//+----------------------------------------------------------------+
//| This function calculates spread in pippettes                   |
//+----------------------------------------------------------------+
double SpreadFinder()
   {
    if (StringFind(Symbol(), "JPY") > 0) 
      Spread = (Ask-Bid)*1000;
    else 
      Spread = (Ask-Bid)*100000;
    return(NormalizeDouble(Spread,1));
   }
        
//+----------------------------------------------------------------+
//| This function opens a long position                            |
//+----------------------------------------------------------------+
int OpenLong(double Lots)
{
  int Magic=0;

  Ticket=OrderSend(CurSymbol,OP_BUY,Lots,Ask,Slippage,0,0,"",Magic,0,Green);                         
  if(Ticket>0)
    {     
    if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
    else
      {
        Print("OpenLong(),OrderSelect() - returned an error : ",GetLastError()); 
        return(-1);
      }   
  }
  else 
  {
    Print("Error opening Buy order : ",GetLastError()); 
    return(-1);
  }
}
 
//+----------------------------------------------------------------+
//| This function opens a short position                           |
//+----------------------------------------------------------------+
int OpenShort(double Lots)
{
  int Magic=0;  
    
  Ticket=OrderSend(CurSymbol,OP_SELL,Lots,Bid,Slippage,0,0,"",Magic,0,Red);                  
  if(Ticket>0)
  {
    if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
      else
         {
           Print("OpenShort(),OrderSelect() - returned an error : ",GetLastError()); 
           return(-1);
         }    
  }
 
   else 
  {
    Print("Error opening Sell order : ",GetLastError()); 
    return(-1);
  }
}
 


//+----------------------------------------------------------------+
//| This function calculates lotsize                               |
//+----------------------------------------------------------------+ 
double LotSize()
{
if (AccountBalance()>=50) Lot=0.02;
if (AccountBalance()>=75) Lot=0.03;
if (AccountBalance()>=100) Lot=0.04;
if (AccountBalance()>=125) Lot=0.05;
if (AccountBalance()>=150) Lot=0.06;
if (AccountBalance()>=175) Lot=0.07;
if (AccountBalance()>=200) Lot=0.08;
if (AccountBalance()>=225) Lot=0.09;
if (AccountBalance()>=250) Lot=0.1;
if (AccountBalance()>=275) Lot=0.11;
if (AccountBalance()>=300) Lot=0.12;
if (AccountBalance()>=325) Lot=0.13;
if (AccountBalance()>=350) Lot=0.14;
if (AccountBalance()>=375) Lot=0.15;
if (AccountBalance()>=400) Lot=0.16;
if (AccountBalance()>=425) Lot=0.17;
if (AccountBalance()>=450) Lot=0.18;
if (AccountBalance()>=475) Lot=0.19;
if (AccountBalance()>=500) Lot=0.20;
if (AccountBalance()>=550) Lot=0.24;
if (AccountBalance()>=600) Lot=0.26;
if (AccountBalance()>=650) Lot=0.28;
if (AccountBalance()>=700) Lot=0.30;
if (AccountBalance()>=750) Lot=0.32;
if (AccountBalance()>=800) Lot=0.34;
if (AccountBalance()>=850) Lot=0.36;
if (AccountBalance()>=900) Lot=0.38;
if (AccountBalance()>=1000) Lot=0.4;
if (AccountBalance()>=1500) Lot=0.6;
if (AccountBalance()>=2000) Lot=0.8;
if (AccountBalance()>=2500) Lot=1.0;
if (AccountBalance()>=3000) Lot=1.2;
if (AccountBalance()>=3500) Lot=1.4;
if (AccountBalance()>=4000) Lot=1.6;
if (AccountBalance()>=4500) Lot=1.8;
if (AccountBalance()>=5000) Lot=2.0;
if (AccountBalance()>=5500) Lot=2.2;
if (AccountBalance()>=6000) Lot=2.4;
if (AccountBalance()>=7000) Lot=2.8;
if (AccountBalance()>=8000) Lot=3.2;
if (AccountBalance()>=9000) Lot=3.6;
if (AccountBalance()>=10000) Lot=4.0;
if (AccountBalance()>=15000) Lot=6.0;
if (AccountBalance()>=20000) Lot=8.0;
if (AccountBalance()>=30000) Lot=12;
if (AccountBalance()>=40000) Lot=16;
if (AccountBalance()>=50000) Lot=20;
if (AccountBalance()>=60000) Lot=24;
if (AccountBalance()>=70000) Lot=28;
if (AccountBalance()>=80000) Lot=32;
if (AccountBalance()>=90000) Lot=36;
if (AccountBalance()>=100000) Lot=40;
if (AccountBalance()>=200000) Lot=80;

double LotTotal=(Lot*MultiLotSize);
return(NormalizeDouble(LotTotal,2));
}
    
//+----------------------------------------------------------------+
//| Int de-init function                                           |
//+----------------------------------------------------------------+  
int deinit()
{   
  return(0);
}  